/*
 * Copyright 2011 Chris de Vreeze
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package eu.cdevreeze.springtx

import org.springframework.{ transaction => springtx }

/**
 * Scala wrapper for a Spring `TransactionOperations`.
 * Trivial to use and understand for users of the Spring `TransactionOperations` API, but idiomatic Scala.
 *
 * @author Chris de Vreeze
 */
trait TransactionOperations {

  def wrappedObject: springtx.support.TransactionOperations

  def execute[T](action: springtx.TransactionStatus => T): T

  def executeWithoutResult(action: springtx.TransactionStatus => Unit): Unit
}
